#include "base64.h"


static char *b64alpha =
  "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
#define B64PAD '='


unsigned int str_len(register char *s)
{
  register char *t;

  t = s;
  for (;;) {
    if (!*t) return t - s; ++t;
    if (!*t) return t - s; ++t;
    if (!*t) return t - s; ++t;
    if (!*t) return t - s; ++t;
  }
}


unsigned int str_chr(register char *s, int c)
{
  register char ch;
  register char *t;

  ch = c;
  t = s;
  for (;;) {
    if (!*t) break; if (*t == ch) break; ++t;
    if (!*t) break; if (*t == ch) break; ++t;
    if (!*t) break; if (*t == ch) break; ++t;
    if (!*t) break; if (*t == ch) break; ++t;
  }
  return t - s;
}

int stralloc_copys(stralloc *sa, char *s)
{
  return stralloc_copyb(sa,s,str_len(s));
}

int stralloc_copyb(stralloc *sa, char *s, unsigned int n)
{
  if (!stralloc_ready(sa,n + 1)) return 0;
  byte_copy(sa->s,n,s);
  sa->len = n;
  sa->s[n] = 'Z'; /* ``offensive programming'' */

  return 1;
}

void byte_copy(register char *to, register unsigned int n, register char *from)
{
  for (;;) {
    if (!n) return; *to++ = *from++; --n;
    if (!n) return; *to++ = *from++; --n;
    if (!n) return; *to++ = *from++; --n;
    if (!n) return; *to++ = *from++; --n;
  }
}

/* returns 0 ok, 1 illegal, -1 problem */


int stralloc_ready(stralloc *out, unsigned int n)
{
	if(out->len < n) return -1;

	return 0;
}


int b64decode(const unsigned char *in, int l, stralloc *out) // out not null terminated
{
  int i, j;
  unsigned char a[4];
  unsigned char b[3];
  char *s;

  if (l == 0)
  {
    if (!stralloc_copys(out,"")) return -1;
    return 0;
  }

  if (!stralloc_ready(out,l + 2)) return -1; // XXX generous
  s = out->s;

  for (i = 0;i < l;i += 4) {
    for (j = 0;j < 4;j++)
      if ((i + j) < l && in[i + j] != B64PAD)
      {
        a[j] = str_chr(b64alpha,in[i + j]);
        if (a[j] > 63) return 1;
      }
      else a[j] = 0;

    b[0] = (a[0] << 2) | (a[1] >> 4);
    b[1] = (a[1] << 4) | (a[2] >> 2);
    b[2] = (a[2] << 6) | (a[3]);

    *s++ = b[0];

    if (in[i + 1] == B64PAD) break;
    *s++ = b[1];

    if (in[i + 2] == B64PAD) break;
    *s++ = b[2];
  }
  out->len = s - out->s;
  while (out->len && !out->s[out->len - 1]) --out->len; // XXX avoid?
  return 0;
}


int b64encode(stralloc *in, stralloc *out)
{
  unsigned char a, b, c;
  int i;
  char *s;

  if (in->len == 0)
  {
    if (!stralloc_copys(out,"")) return -1;
    return 0;
  }

  if (!stralloc_ready(out,in->len / 3 * 4 + 4)) return -1;

  s = out->s;

  for (i = 0;i < in->len;i += 3) {
    a = in->s[i];
    b = i + 1 < in->len ? in->s[i + 1] : 0;
    c = i + 2 < in->len ? in->s[i + 2] : 0;

    *s++ = b64alpha[a >> 2];
    *s++ = b64alpha[((a & 3 ) << 4) | (b >> 4)];

    if (i + 1 >= in->len) *s++ = B64PAD;
    else *s++ = b64alpha[((b & 15) << 2) | (c >> 6)];

    if (i + 2 >= in->len) *s++ = B64PAD;
    else *s++ = b64alpha[c & 63];
  }
  out->len = s - out->s;
  return 0;
}

